<template>
  <section app>
    <div faketoolbar></div>
    <md-app l1ce md-mode='fixed'>

      <!-- menu -->
      <md-app-drawer drawer md-persistent="full" :md-active.sync="menuVisible">

        <!-- left part of top toolbar -->
        <md-toolbar class="md-primary" top-bar md-elevation="0">
          <span title>Level-1<br>Configuration Editor</span>
          <md-button class="md-icon-button" @click="menuVisible = !menuVisible;">
            <md-icon md-src="/img/md/arrow_left.svg"/>
          </md-button>
        </md-toolbar>

        <!-- left part of second top bar -->
        <md-toolbar ripple-bar class="md-primary" md-elevation="0">
          <a flex href="/api/v0/login" target="blank" v-if="!store.state.auth.token">
            <md-ripple>
              <md-icon md-src="/img/md/vpn_key.svg"/>
              <span class="md-title">login</span>
            </md-ripple>
          </a>
          <div v-else>
            <md-button class="md-icon-button">
              <md-icon md-src="/img/md/power_settings_new.svg" @click='logout'/>
            </md-button>
            <span class="md-title">{{username}}</span>
          </div>
        </md-toolbar>

        <ul>
          <router-link to='/changes' tag=li>
            <md-ripple>
              <md-icon md-src="/img/md/inbox.svg"/>
              <md-badge flex v-if="store.get.database('mychanges').length" :md-content="store.get.database('mychanges').length">
                My Changes
              </md-badge>
              <p flex v-else>My Changes</p>
            </md-ripple>
          </router-link>
          <!-- <router-link to='/workflows' tag=li>
            <md-ripple>
              <md-icon md-src="/img/md/playlist_play.svg"/>
              <span flex>Workflows</span>
            </md-ripple>
          </router-link> -->
          <router-link to='/editor' tag=li>
            <md-ripple>
              <md-icon md-src="/img/md/build.svg"/>
              <span flex>Edit</span>
            </md-ripple>
            <ul>
              <md-list-item>
                <md-field md-clearable @click="showSubsystemMenu = true">
                  <label>Subsystem</label>
                  <md-menu md-direction="bottom-start" md-dense md-align-trigger md-full-width :md-active.sync="showSubsystemMenu">
                    <md-input v-model="selectedSubsystem"
                              @click.stop.prevent="openSubsystemMenu"
                              @focus.stop="showSubsystemMenu = true"/>
                    <md-menu-content row-entry-menu>
                      <template v-if="subsystemTableKeys.length === 0">
                        <p>loading..</p>
                      </template>
                      <template v-else>
                        <p @click.stop="">showing {{filterSearch(subsystemSearch, subsystemTableKeys).length}}/{{subsystemTableKeys.length}} options</p>
                        <input ref="subsystemsearch" type="text" @click.stop="" v-model="subsystemSearch" placeholder="search">
                        <md-menu-item v-for="option in filterSearch(subsystemSearch, subsystemTableKeys)" :key="option" @click="selectSubsystem(option)">{{option}}</md-menu-item>
                      </template>
                    </md-menu-content>
                  </md-menu>
                </md-field>
              </md-list-item>
              <md-list-item>
                <md-field md-clearable @click="showSectionMenu = true">
                  <label>Section</label>
                  <md-menu md-direction="bottom-start" md-dense md-align-trigger md-full-width :md-active.sync="showSectionMenu">
                    <md-input v-model="selectedSection"
                              @click.stop.prevent="openSectionMenu"
                              @focus.stop="showSectionMenu = true"/>
                    <md-menu-content row-entry-menu>
                      <template v-if="getSectionOptions(selectedSubsystem).length === 0">
                        <p>loading..</p>
                      </template>
                      <template v-else>
                        <p @click.stop="">showing {{filterSearch(sectionSearch, getSectionOptions(selectedSubsystem)).length}}/{{getSectionOptions(selectedSubsystem).length}} options</p>
                        <input ref="sectionsearch" type="text" @click.stop="" v-model="sectionSearch" placeholder="search">
                        <md-menu-item v-for="option in filterSearch(sectionSearch, getSectionOptions(selectedSubsystem))" :key="option" @click="selectSection(option)">{{option}}</md-menu-item>
                      </template>
                    </md-menu-content>
                  </md-menu>
                </md-field>
              </md-list-item>
            </ul>
          </router-link>
          <router-link to='/compare' tag=li>
            <md-ripple>
              <md-icon md-src="/img/md/compare_arrows.svg"/>
              <span flex>Compare</span>
            </md-ripple>
            <ul>
              <md-list-item>
                <md-field md-clearable @click="showSubsystemMenu2 = true">
                  <label>Subsystem</label>
                  <md-menu md-direction="bottom-start" md-dense md-align-trigger md-full-width :md-active.sync="showSubsystemMenu2">
                    <md-input v-model="selectedSubsystem"
                              @click.stop.prevent="openSubsystemMenu2"
                              @focus.stop="showSubsystemMenu2 = true"/>
                    <md-menu-content row-entry-menu>
                      <template v-if="subsystemTableKeys.length === 0">
                        <p>loading..</p>
                      </template>
                      <template v-else>
                        <p @click.stop="">showing {{filterSearch(subsystemSearch, subsystemTableKeys).length}}/{{subsystemTableKeys.length}} options</p>
                        <input ref="subsystemsearch2" type="text" @click.stop="" v-model="subsystemSearch" placeholder="search">
                        <md-menu-item v-for="option in filterSearch(subsystemSearch, subsystemTableKeys)" :key="option" @click="selectSubsystem(option)">{{option}}</md-menu-item>
                      </template>
                    </md-menu-content>
                  </md-menu>
                </md-field>
              </md-list-item>
              <md-list-item>
                <md-field md-clearable @click="showSectionMenu = true">
                  <label>Section</label>
                  <md-menu md-direction="bottom-start" md-dense md-align-trigger md-full-width :md-active.sync="showSectionMenu2">
                    <md-input v-model="selectedSection"
                              @click.stop.prevent="openSectionMenu2"
                              @focus.stop="showSectionMenu2 = true"/>
                    <md-menu-content row-entry-menu>
                      <template v-if="getSectionOptions(selectedSubsystem).length === 0">
                        <p>loading..</p>
                      </template>
                      <template v-else>
                        <p @click.stop="">showing {{filterSearch(sectionSearch, getSectionOptions(selectedSubsystem)).length}}/{{getSectionOptions(selectedSubsystem).length}} options</p>
                        <input ref="sectionsearch2" type="text" @click.stop="" v-model="sectionSearch" placeholder="search">
                        <md-menu-item v-for="option in filterSearch(sectionSearch, getSectionOptions(selectedSubsystem))" :key="option" @click="selectSection(option)">{{option}}</md-menu-item>
                      </template>
                    </md-menu-content>
                  </md-menu>
                </md-field>
              </md-list-item>
            </ul>
          </router-link>
          <router-link to='/admin' tag=li v-if="store.get.auth('isAdmin')">
            <md-ripple>
              <md-icon md-src="/img/md/security.svg"/>
              <span flex>Admin</span>
            </md-ripple>
            <!-- <ul>
              <md-ripple><md-list-item>lala</md-list-item></md-ripple>
              <md-list-item>lala</md-list-item>
            </ul> -->
          </router-link>
        </ul>
      </md-app-drawer>

      <!-- right part of top bar -->
      <md-app-toolbar class="md-primary" top-bar md-elevation="0">
        <md-button class="md-icon-button" v-if="!menuVisible" @click="menuVisible = !menuVisible;">
          <md-icon md-src="/img/md/menu.svg"/>
        </md-button>
        <md-button class="md-icon-button">
          <md-icon md-src="/img/md/help_outline.svg"/>
        </md-button>
        <span flex></span>
        <!-- <input search type="text">
        <span flex></span> -->
        <span toolbarbutton :connectionstate="store.state.websocket.connectionState">{{store.state.websocket.connectionState}}</span>
        <DBMode toolbarbutton></DBMode>
        <DBName toolbarbutton></DBName>
      </md-app-toolbar>

      <md-app-content content>
        <keep-alive>
          <router-view/>
        </keep-alive>
      </md-app-content>
    </md-app>
    <AlertManager />
  </section>
</template>

<script lang="ts">
import { Component, Vue, Watch } from 'vue-property-decorator';
import { mapState } from 'vuex';
import { store } from './store';
import { KeyPathKey } from './store/editor';
import DBName from './components/app/database.vue';
import DBMode from './components/app/mode.vue';
import AlertManager from './components/app/alertmanager.vue';
import router from './lib/router';
import { MdApp,
         MdList,
         MdIcon,
         MdDrawer,
         MdToolbar,
         MdContent,
         MdButton,
         MdRipple,
         MdBadge,
         MdAutocomplete,
         MdField,
         MdMenu } from 'vue-material/dist/components';
import { setTimeout } from 'timers';
import { watch } from 'fs';

declare global {
  interface Window {
    cernOauth: any;
  }
}

Vue.use(MdApp);
Vue.use(MdList);
Vue.use(MdIcon);
Vue.use(MdDrawer);
Vue.use(MdToolbar);
Vue.use(MdContent);
Vue.use(MdButton);
Vue.use(MdRipple);
Vue.use(MdBadge);
Vue.use(MdAutocomplete);
Vue.use(MdField);
Vue.use(MdMenu);
@Component({
  components: {
    DBMode,
    DBName,
    AlertManager,
  },
})
export default class extends Vue {

  private menuVisible = true;
  private selectedSubsystem = '';
  private selectedSection = '';

  private showSubsystemMenu = false;
  private showSectionMenu = false;
  private showSubsystemMenu2 = false;
  private showSectionMenu2 = false;
  private subsystemSearch = '';
  private sectionSearch = '';

  public created() {
    router.afterEach(() => this.syncSectionSelectionFromURL());

    Promise.all([
      store.dispatch.editor('readURLData'),
      store.dispatch.database('getSubsystemTables'),
    ])
    .then(() => this.syncSectionSelectionFromURL());

    store.dispatch.websocket('socketConnect');
    store.dispatch.database('getChanges');
  }

  @Watch('selectedSection')
  public sectionChanged(val: string, oldVal: string) {
    if (!this.selectedSection) {
      store.commit.editor('setKeyPath', []);
    } else if (store.state.database.subsystemTables) {
      const subsystemEntry = store.state.database.subsystemTables[this.selectedSubsystem];
      const sectionKey = subsystemEntry &&
        Object.keys(subsystemEntry.blocks)
        .find(k => subsystemEntry.blocks[k].alias === this.selectedSection);
      if (sectionKey) {
        const tableName = subsystemEntry.blocks[sectionKey].table;
        const urlPieces = store.state.editor.keyPath;
        const urlTableName = urlPieces[0] && urlPieces[0].tableName;
        if (urlTableName !== tableName) {
          const keyPath: KeyPathKey[] = [{tableName, key: '', options: {}}];
          store.commit.editor('setKeyPath', keyPath);
        }
      }
    }
  }

  get store() {
    return store;
  }

  get username() {
    const userData = store.state.auth.userData;
    return userData && userData.cern && userData.cern.fullname;
  }

  get subsystemTableKeys() {
    return Object.keys(store.state.database.subsystemTables);
  }

  private filterSearch(search: string, options: string[]): string[] {
    return options.filter(o => o.toLowerCase().indexOf(search.toLowerCase()) !== -1).slice(0, 50);
  }

  private selectSubsystem(option: string) {
    this.selectedSubsystem = option;
    this.showSubsystemMenu = false;
    this.showSubsystemMenu2 = false;
  }

  private selectSection(option: string) {
    this.selectedSection = option;
    this.showSectionMenu = false;
    this.showSectionMenu2 = false;
  }

  private openSubsystemMenu() {
    this.showSubsystemMenu = true;
    const s = this.$refs.subsystemsearch as HTMLElement;
    if (s) {
      s.focus();
    }
  }

  private openSubsystemMenu2() {
    this.showSubsystemMenu2 = true;
    const s = this.$refs.subsystemsearch2 as HTMLElement;
    if (s) {
      s.focus();
    }
  }

  private openSectionMenu() {
    this.showSectionMenu = true;
    const s = this.$refs.sectionsearch as HTMLElement;
    if (s) {
      s.focus();
    }
  }

  private openSectionMenu2() {
    this.showSectionMenu2 = true;
    const s = this.$refs.sectionsearch2 as HTMLElement;
    if (s) {
      s.focus();
    }
  }

  private syncSectionSelectionFromURL() {
    const route = router.currentRoute;
    const firstKeyPath = store.state.editor.keyPath[0];
    if (route.name === 'editor' && firstKeyPath && firstKeyPath.tableName) {
      const firstTableName = firstKeyPath.tableName;
      Object.keys(store.state.database.subsystemTables).find(subsystemName => {
        const subsystemEntry = store.state.database.subsystemTables[subsystemName];
        return !!Object.keys(subsystemEntry.blocks).find(sectionKey => {
          const sectionEntry = subsystemEntry.blocks[sectionKey];
          const tableName = sectionEntry.table;
          if (tableName === firstTableName) {
            this.selectedSubsystem = subsystemName;
            this.selectedSection = sectionEntry.alias;
            return true;
          }
          return false;
        });
      });
    }
  }

  private getSectionOptions(selectedSubsystem) {
    if (!store.state.database.subsystemTables || !store.state.database.subsystemTables[selectedSubsystem]) {
      this.selectedSection = '';
      return [];
    } else {
      const match = store.state.database.subsystemTables[selectedSubsystem];

      return Object.keys(match.blocks).map(k => match.blocks[k].alias);
    }
  }

  private logout() {
    store.dispatch.auth('logout');
  }

  get fullscreenEditorOpen() {
    const keyPath = store.state.editor.keyPath;
    if (!keyPath || keyPath.length === 0) {
      return false;
    }
    const lastKeyPath = keyPath[keyPath.length - 1];
    return !!lastKeyPath.options.clob && !!lastKeyPath.options.fullscreen;
  }

  @Watch('fullscreenEditorOpen')
  private fullscreenEditorOpenChanged(val, oldVal) {
    this.menuVisible = !val;
  }
}
</script>

<style lang="scss" scoped>
  @import "~vue-material/src/components/MdAnimation/variables";

  // full height
  [app], [l1ce] {
    height: 100%;
  }

  [flex] {
    flex: 1;
  }

  // [search] {
  //   flex: 2;
  //   background: #ffffff21;
  //   border: none;
  //   font-size: 1.4em;
  //   padding: 5px 20px;
  //   border-radius: 5px;
  //   color: white;
  // }

  // fucky animations screw up the top bars
  // put some fake ones underneath to hide that
  [faketoolbar] {
    // from MdToolbar.vue
    $md-toolbar-height: 64px;
    $md-toolbar-height-portrait: 56px;
    $md-toolbar-height-landscape: 48px;
    $md-toolbar-height-dense: 48px;
    min-height: $md-toolbar-height;
    @include md-layout-small {
      min-height: $md-toolbar-height-landscape;
    }
    @include md-layout-xsmall {
      min-height: $md-toolbar-height-portrait;
    }

    position: absolute;
    top: 0;
    height: 10px;
    left: 0;
    right: 0;
    z-index: 0;
    pointer-events: none;
    @include md-theme-property-darken(background, primary, "primary", 5%);
  }
  .md-app.md-theme-default[l1ce][l1ce][l1ce] {
    background-color: transparent;
  }

  // by default content has padding, remove it for full control over content
  [content] {
    padding: 0;
    height: 100%;
  }

  [top-bar] {
    display: flex;
    flex-direction: row;
    padding-right: 0;
    font-size: 1.4em;
    &.md-primary {
      @include md-theme-component() {
        @include md-theme-property-darken(background, primary, "primary", 5%);
      }
    }

    [title] {
      flex: 1;
    }
  }

  [ripple-bar] {
    padding: 0;
    &>* {
      display: flex;
      align-items: center;
      padding: 8px 16px;
    }
  }

  [toolbarbutton] {
    padding: 0 20px;
    height: 100%;
    display: flex;
    flex-direction: column;
    align-items: center;
    justify-content: center;

    &[connectionstate='offline'] {
      background: $red;
    }
  }

  [drawer] {
    width: 250px;
    ul {
      width: 100%;
      list-style: none;
      padding: 0;
      .md-list-item-content {
        flex-wrap: wrap;
      }
      li {
        &:not(.router-link-active) {
          ul {
            height: 0;
            opacity: 0;
            transform: translate3D(0, -10px, 0);
          }
        }
        ul {
          height: auto;
          opacity: 1;
          overflow: hidden;
          transform: none;
          transition: .4s $md-transition-stand-timing;
          transition-property: transform, opacity;
          will-change: transform, opacity;
        }
        & > .md-ripple {
          padding: 4px 16px;
          min-height: 48px;
          display: flex;
          align-items: center;
          justify-content: space-between;
        }
        [flex] {
          flex: 1;
        }
        i {
          margin-right: 32px;
        }
      }
    }
    @include md-theme-component() {
      @include md-theme-property-darken(background, primary, "primary", 5%);
      ul {
        li {
          &.router-link-active {
            & > .md-ripple {
              @include md-theme-property(background, accent);
            }
          }
          ul {
            @include md-theme-property-darken(background, primary, "primary", 10%);
          }
        }
        @include md-theme-property(color, background);
      }
    }
  }
</style>
<style lang="scss">
body {
  background: white;
}
[l1ce] > [drawer] {
  @include md-theme-component() {
    .md-icon svg {
      @include md-theme-property(fill, background);
    }
    .md-field {
      &::after {
        background-color: rgba(255, 255, 255, .42);
      }
      &.md-focused,
      &.md-has-value {
        .md-input,
        .md-textarea {
          -webkit-text-fill-color: white;
        }
      }
      label, i {
        color: white;
      }
    }
  }
}
.md-app .md-app-content {
  border: 0;
}
</style>
